program dsapp; {by David A. Burton, of Burton Systems Software, (919) 469-3068.
                   POB 4156, Cary, NC  27519.  This program is NOT copyrighted.}
procedure givehelp;
  begin
    writeln('DSAPP - delta-script application');
    writeln(#10#13'usage:  DSAPP <oldfile> <newfile> <deltascript>');
    writeln(#10#13'   <deltascript> is applied to <oldfile>, creating <newfile>');
    writeln(#10#13'<deltascript> can be created using CMPR with the INSDEL option.  CMPR is');
    writeln('part of the TLIB Source Code Version Control System, from Burton Systems');
    writeln('Software, POB 4156, Cary, NC 27519 USA.  Phone: (919) 469-3068.');
    halt(1);
  end; {help}

procedure OpenInp(var textfile: text; name: string);
  begin
    {$I-}
    assign(textfile,name);
    reset(textfile);
    {$I+}
    if 0 <> ioresult then
      begin
        writeln('File not found: ',name);
        halt(1);
      end{if};
  end; {OpenInp}

var oldfile, deltascript, newfile: text; {the three file variables}
    lineno, newlineno: longint; {line nums in oldfile & newfile, respectively}
    line: string; {a 1-line buffer}
    dot, cmd: char; {'.', and 'I' (insert) or 'D' (delete)}
    where, numlines, i: longint; {W & N of ".I W N", and a counter}

procedure getaline;
  begin
    readln(oldfile,line);
    lineno := lineno + 1;
  end; {getaline}

procedure putaline;
  begin
    {$I-}
    writeln(newfile,line);
    {$I+}
    if 0 <> ioresult then
      begin
        writeln('write error - disk full?');
        halt(1);
      end;
    newlineno := newlineno + 1;
  end; {putaline}

begin {main}
  if 3 <> ParamCount then
      givehelp;
  OpenInp(oldfile,ParamStr(1));
  OpenInp(deltascript,ParamStr(3));
  {$I-}
  assign(newfile,ParamStr(2));
  rewrite(newfile);
  {$I+}
  if 0 <> ioresult then
    begin
      writeln('Could not create: ',ParamStr(2));
      halt(1);
    end{if};
  lineno := 0;
  newlineno := 0;
  while not eof(deltascript) do
    begin
      readln(deltascript,dot,cmd,where,numlines);
      if ('.'<>dot) or (('I'<>cmd)and('D'<>cmd)) then
        begin
          writeln('delta-script format error');
          halt(1);
        end{if};
      if 'D' = cmd then
          where := where - 1;
      while lineno < where do
        begin
          getaline;
          putaline;
        end{while};
      if 'I' = cmd then
        begin {insert}
          for i := 1 to numlines do
            begin
              readln(deltascript,line);
              putaline;
            end;
        end
      else {delete}
           for i := 1 to numlines do
               getaline;
    end{while};
  while not eof(oldfile) do
    begin
      getaline;
      putaline;
    end{while};
  close(newfile);
  line := ParamStr(2);
  for i := 1 to length(line) do
      line[i] := UpCase(line[i]);
  writeln(lineno,' old lines, ',newlineno,' new lines.  ',line,' created.');
end.
