MAKE(I)                                                               MAKE(I)

| <- note change bars


NAME
        MAKE - maintain multiple source files (MS-DOS 2.x/3.x and VAX/VMS)


SYNOPSIS
        MAKE [-N] [-A] [-F makefile] [name ...]
   or   MAKE ?


FILES
        MAKE consists of the following files: MAKE.BAT, MAKEEXE.EXE, and
        DELBAT.BAT.  When you use MAKE, these three files should be in either
        the current directory or in a directory mentioned in your PATH.

        The instructions for MAKE are in this file, MAKE.MAN.

        A temporary file called MAKE$$$$.BAT is created by MAKE; this file
        will be deleted when MAKE has finished (unless DELBAT.BAT is missing).

        The source code for MAKE is in an archive file, MAKESRC.ZIP.


DESCRIPTION
        MAKE is a utility inspired by the Unix(tm) command of the same
        name.  MAKE helps maintain programs that are constructed from
        many files.  MAKE processes a "makefile", a file which describes
        how to build a program from its source files, and produces a
        script file containing the commands necessary to recompile the
        program.  (Note: "script" is Unix lingo for ".bat")

        Be careful: this MAKE is NOT compatible with Unix(tm) MAKE!

        The 'N' option causes MAKE to print out the steps it would follow
        in order to rebuild the program.  The 'A' option tells MAKE to
        assume that all files are obsolete, and that everything should be
        recompiled.  The 'F' option, followed by a filename, can be used
        to specify a makefile other than the default one.

        If no names are specified in the commandline, the first dependency
        in the makefile is examined.  Otherwise, the specified root names
        are brought up to date.

        The default makefiles are:

                for MS-DOS:     MAKEFILE
                                ..\MAKEFILE

                for VAX/VMS:    MAKEFILE
                                [-]MAKEFILE
                                SYS$LOGIN:MAKEFILE

        If the first makefile cannot be found, MAKE attempts to use the
        next one.  If no makefile is ever found, MAKE prints a diagnostic
        and aborts.





THE MAKEFILE
        Comments begin with '!' and extend to the end of the line.  A
        '!' (or almost any other character) may be escaped with the escape
        character (backquote (`) on MS-DOS, backslash (\) on VMS).  An escape
        character may be typed by doubling it (`` or \\).  The standard
        Unix escape codes are recognized (`n, `r, `t, `b, `f,  \n, \r, \t,
        \b and \f).

        A makefile is a list of dependencies.  A dependency consists of
        a root name, a colon, and zero or more names of dependent files.
        (The colon MUST be preceeded by whitespace.)  For instance, in:

                make.exe : make.obj parsedir.obj file.obj macro.obj mk.h

        the file 'make.exe' depends on five other files.  A root name
        with an empty dependency, as in:

                print :

        is assumed NEVER up to date, and will always be recompiled.

        The dependency list may be continued on successive lines:

                bigfile.exe : one.obj two.obj three.obj four.obj
                five.obj six.obj gronk.obj freeple.obj scuzzy.lnk
                frog.txt greeble.out

        Any number of 'method' lines may follow a dependency.  Method lines
        begin with whitespace.  When a file is to be recompiled, MAKE copies
        these method lines (minus the leading blanks or tab) to the script
        (.bat) file.  For example, in:

                make.exe : make.obj parsedir.obj file.obj macro.obj mk.h
                        link make,parsedir,file,macro
                        echo "Just another version of MAKE ..."

        the two lines following the dependency make up the method for
        recompiling (or in this case, re-linking) the file 'make.exe'.

        If the macro "~INIT" is defined, its text will appear first in the
        script file.  If the macro "~DEINIT" is defined, its text will
        appear last in the script file.  By defining these two macros, it
        is possible to set the directory or whatever:

                ~INIT = echo on`ncd \workdir`nif not exist qwarkle.xyz goto exit
                ~DEINIT = :exit`ncd \
                ~DEINIT = #(~DEINIT)`necho "Done."

        will expand (in the script file) to:

                echo on
                cd \workdir
                if not exist qwarkle.xyz goto exit
                .
                .
                :exit
                cd \
                echo "Done."

        When a root's method is defined, the value of the macro "~BEFORE"
        is prefixed to the method, and the value of the macro "~AFTER" is
        appended to it.

        Frequently one wants to maintain more than one program with a single
        makefile.  In this case, a "master dependency" can appear first in
        the file:

                allOfMyToolsAndHorribleHacks : cat peek poke.exe grunge
                cat : cat.exe
                cat.exe : ....
                        (stuff for CAT.EXE)
                peek : peek.exe
                peek.exe : (stuff for PEEK.EXE)
                poke.exe : (stuff for POKE.EXE)
                grunge : grunge.com
                grunge.com : (stuff for grung)

        In other words, make will bring everything up to date that is somehow
        connected to the first dependency (the incredibly lengthy filename
        specified in this example can't actually exist).





ARCHIVED FILES
(MS-DOS version only)
        Sometimes you may wish to keep seldom-used files in an archive file,
|       using PKPAK/PKXPAK (formerly called PKARC/PKXARC) to extract and/or
        update them when necessary.

        To facilitate this, MAKE can reference files within an .ARC file
        as easily as `normal' files.  Simply pretend that the archive file
        is a subdirectory, and use the name of the archive as part of the
        path, like this:

                c:\x.arc\poke.exe : files.obj c:\x.arc\poke.obj io.lib
|                       pkxpak x.arc poke.obj /r >nul
                        link poke files,poke,,io
|                       pkpak u c:\x.arc poke.exe
                        del poke.obj
                        del poke.exe

        Note that MAKE cannot handle "nested" .ARC files.  That is, MAKE
        cannot reference files in archives which are, themselves, in
        archives, like "c:\x.arc\y.arc\noway.c".





| TLIB LIBRARIES
| (MS-DOS version only)
|       MAKE is now "integrated" with TLIB, so that it can test the dates
|       of individual versions and branches within TLIB libraries.  Simply
|       specify the version you want in brackets after the file name, like
|       this:
|
|               myfile.c : myfile.tlb[4.*]
|                       tlib r myfile.c 4.*
|
|       You can also use a TLIB file list or snapshot version label to
|       specify the version.  For example:
|
|               myfile.c$[@beta] : myfile.c
|                       tlib p *.?$? a myfile.c @beta





MACROS
        A macro is defined by a line of the form (the '=' MUST be surrounded
        by whitespace):

                <macro-name> = <macro-body>

        A macro may be deleted by assigning an empty value to it.  Macros
        may be redefined, but old definitions stay around.  If a macro is
        redefined, and the redefinition is later deleted, the first definition
        will take effect:

                MAC = first                     ! MAC = "first"
                MAC = second                    ! MAC = "second"
                MAC = #(MAC) third              ! MAC = "second third"
                MAC =                           ! MAC = "second"
                MAC =                           ! MAC = "first"
                MAC =                           ! MAC has no definition

        A macro may be referenced in two ways:

                        #<char>   or    #(macro-name)

        The first way only works if the macro's name is a single character.
        If the macro's name is longer than one character, it must be
        enclosed in parenthesis.  ['#' may be escaped by doubling it ("##".)]
        For example, in:

                G = mk.h mk1.h
                OBJS = make.obj file.obj parsedir.obj macro.obj
                BOTH = #(OBJS) #G

                make.exe : #(OBJS) #G
                make.exe : #(BOTH)
                make.exe : mk.h mk1.h make.obj file.obj parsedir.obj macro.obj
                        $write sys$output "This is a number sign --> ##"

        after macro expansion, the three dependencies will appear identical
        and the two '#'s in the last line will turn into one '#'.




| DOS ENVIRONMENT VARIABLES
| (MS-DOS version only)
|       All DOS environment variables are available within MAKE as pre-defined
|       macro names which begin and end with "%".  For example, the DOS
|       command processor (usually command.com) is selected by the COMSPEC
|       environment variable, so you could specify it as #(%COMSPEC%) in
|       your makefile.  For example, you could run a DOS .bat file called
|       compile.bat like this:
|
|               myfile.obj : myfile.c
|                       #(%COMSPEC%) /C compile myfile.c





UNIX(tm) MAKE AND THIS ONE
        They are NOT the same.  Do not expect Unix makefiles to work with
        this MAKE, even if you change the pathnames.  There are major
        differences between this version and the standard Unix(tm) MAKE:

        1. The Unix(tm) comment character is '#', DOS & VAX/VMS's is '!'.

        2. The Unix(tm) macro-expansion character is '$'.  While this would
           have been easy to leave the same, the '$' character is used so
           often in VAX/VMS command-lines that I thought it best to change
           it to '#'.

        3. Multiple root names are not allowed.  Unix(tm) MAKE accepts lines
           of the form:

                name1 name2 : depend1 depend2

           but this one doesn't.

        4. With Unix MAKE, method lines must be preceeded by a tab character.
           Since TLIB (and many MS-DOS editors) convert tabs to blanks, this
           version of MAKE allows method lines to be preceeded by either
           blanks or tabs.

        5. There is no equivalent of double-colon ("::".)

        6. There is no equivalent of .SUFFIXES, or the corresponding special
           macros.





SAMPLE MAKEFILE

! MS-DOS Make utility
! (compile with Lattice C version 2.13)
!
! Adjust these for your system:
CLIB = \lc\s\lc
COBJ = \lc\s\c
~INIT = echo on

H = makedefs.h
FILES = #H make.c macro.c token.c parsedir.c file.c osdate.asm
DOCUMENTATION = readme make.man makefile

make.obj : make.c #H
        lc1 make
        lc2 make

macro.obj : macro.c #H
        lc1 macro
        lc2 macro

token.obj : token.c #H
        lc1 token
        lc2 token

parsedir.obj : parsedir.c #H
        lc1 parsedir
        lc2 parsedir

file.obj : file.c
        lc1 file
        lc2 file

osdate.obj : osdate.asm
        masm osdate;

! Print files associated with MAKE
print :
        print make.man #(FILES) makefile

! collect source and documentation files
collect :
        collect -o make.src @make.lis

! copy to distribution disk (on A:)
distribution :
        copy readme a:
        copy make.man a:
        copy makefile a:
        copy make.bat a:
        copy make.c a:
        copy macro.c a:
        copy token.c a:
        copy parsedir.c a:
        copy file.c a:
        copy osdate.asm a:
        copy cmake.bat a:
        copy make.lis a:
        copy makeexe.exe a:
        copy makedefs.h a:

makeexe.exe : make.obj macro.obj token.obj parsedir.obj file.obj osdate.obj
        link #(COBJ) make macro token parsedir file osdate,makeexe,,#(CLIB)





AUTHOR
        Landon Dyer                     G.DYER@SU-SCORE.ARPA
        10815 Northview Square
        Cupertino, CA 95014

   or   c/o Dyers
        Box 330-A, Route 2
        Lenoir City, TN 37771


Document & program revised 3/86-11/88 by:
        David Burton
        Burton Systems Software         (919) 469-3068
        POB 4156
        Cary, NC 27519
