#include <stdio.h>


/* For each bit in (d1,d2,d3), the corresponding result bit is "1" iff
   at least two of the three input bits are "1".  */
int vote_by_bit( int d1, int d2, int d3 )
  {
   int ands, ors, xors, result;
    ands = d1 & d2 & d3;  /* bits set (1) iff all 3 input bits are set */
    ors = d1 | d2 | d3;  /* bits clear (0) iff all 3 input bits are clear */
    xors = d1 ^ d2 ^ d3;  /* bits set (1) iff 1 or 3 input bits are set */
    result = ((~xors) | ands) & ors;  /* bits set iff 2 or 3 input bits are set */
   #ifdef debug
     printf( "Vote(%d,%d,%d) = %d\n", d1, d2, d3, result );
   #endif
    return result;
  } /* vote_by_bit */


int main( int argc, char *argv[] )
  {
    vote_by_bit( 0x00, 0x00, 0x00 );
    vote_by_bit( 0x00, 0x00, 0x11 );
    vote_by_bit( 0x00, 0x11, 0x00 );
    vote_by_bit( 0x00, 0x11, 0x11 );
    vote_by_bit( 0x11, 0x00, 0x00 );
    vote_by_bit( 0x11, 0x00, 0x11 );
    vote_by_bit( 0x11, 0x11, 0x00 );
    vote_by_bit( 0x11, 0x11, 0x11 );
    return 0;
  } /*main*/
