;ZIP  --  fill memory with specified byte		  D. Burton  6/19/86

; for testing programs which may not have all variables properly initialized

; Assemble & link as follows (lines from my MAKEFILE):
;
;     zip.com : zip.asm
;	      masm zip,zip,nul,nul
;	      if errorlevel 1 goto xitzip
;	      link zip,zip,nul,,
;	      del zip.obj
;	      exe2bin zip.exe zip.com
;	      del zip.exe
;	      :xitzip


zip segment public
	assume cs:zip,ds:zip

	org	100h

; Entry point
entry:
	mov	sp,offset(endstack)  ;use our own stack

;first, get the 2-digit hex number from the parameter line
	mov	al,ds:[80h]	;length byte from command line
	cmp	al,3		;make sure there are at least 3 chars in parms
	jc	err1		;if not, exit with error message
	mov	al,ds:[82h]	;high digit
	call	hexdigit
	mov	cl,4
	shl	al,cl
	mov	dl,al
	mov	al,ds:[83h]	;low digit
	call	hexdigit
	add	dl,al
err1:	jc	err2
	mov	dh,dl		;DH=DL=what we're going to fill memory with
;			      (yes, I used a preposition to end a sentence with)


;put number (from DL) into msg area
	mov	di,offset(number)    ;where to stuff the hex numerals for msg
	mov	al,dl		;what to stuff
	call	putbyte 	;stuff 'em

;output message string

	push	dx
	mov	dx,offset(banner$)   ;print a message
	mov	ah,09h
	int	21h		;print string

;free memory beyond our stack area
	mov	bx,16+offset(endstack)
	mov	cl,4
	shr	ax,cl		;convert length from bytes to paragraphs
	mov	ax,4A00h	;4A is the SETBLOCK function
	int	21h		;free memory beyond our stack
	jc	err3

;ask DOS how much memory is available, then allocate it
	mov	bx,0FFFFh	;ask for the moon
	mov	ax,4800h	;48 is the ALLOCATE MEMORY function
	int	21h
	jnc	err4		;it is supposed to fail, of course
	push	bx		;remember how much memory is available
	mov	ax,4800h	;so we'll ask again, for...
	int	21h		;...the amount which is actually available
	pop	bx		;the number of paragraphs of memory we have
	jc	err5

;fill it with zeros
	mov	es,ax		;segment addr of the memory (returned by DOS)
	pop	dx		;what to stuff into memory
	mov	ax,dx
	sub	ch,ch
	mov	cl,bl
	shl	cx,1
	shl	cx,1
	shl	cx,1		;CX is the number of words accounted for by BL
	sub	di,di		;ES:0 points to the memory we're going to zap
	cld
	rep stosw		;fill 'em
	or	bh,bh		;is that all there is?
	jz	weRdone 	;if so, quit

	mov	ax,es		;add to ES the number of paragraphs we zeroed
	sub	ch,ch
	mov	cl,bl
	add	ax,cx
	mov	es,ax

lupe:	mov	cx,2048 	;256 paragraphs = 2048 words to zap at a time
	mov	ax,dx		;fill 'em with DX's
	sub	di,di		;chunk starts at ES:0 (DI contains the 0)
	rep stosw
	mov	ax,es		;add 256 to ES
	inc	ah
	mov	es,ax
	dec	bh		;count the chunk
	jnz	lupe

;print "done" message
weRdone: mov	dx,offset(done$) ;print a message
	jmp	xitmsg

err2:
	mov	dx,offset(errmsg$)  ;"usage" error message
	jmp	xitmsg
err3:
err4:
err5:	pop	dx		;restore SP (not really needed)
	mov	dx,offset(DOSerr$)  ;"DOS error" error message

xitmsg: mov	ah,09h
	int	21h		;print string

xit:	int	20h		;exit

;stuff Ascii code (2 digits) for a byte (in AL) into [DI] and [DI+1]
;all registers are preserved (except flags)
putbyte:
	push	ax
	inc	di
	call	putdigit
	dec	di
	mov	cl,4
	shr	al,cl
	call	putdigit
	pop	ax
	ret

;subroutine of putbyte (stuff a single numeral)
putdigit:
	push	ax
	and	al,0Fh
	add	al,30h
	cmp	al,3Ah
	jc	putit
	add	al,7
putit:	mov	[di],al
	pop	ax
	ret

;convert a digit (nibble) in AL from Ascii character to 4 bit binary
;All other registers are preserved (except flags)
hexdigit:
	sub	al,30h
	cmp	al,10
	jc	gotit
	sub	al,7
	and	al,0Fh
gotit:	ret

;data area
banner$ db  13,10,'Zapping memory with '
number	db  ' ',' ',13,10,36
done$	db  'Done.',13,10,36
DOSerr$ db  '***error***',13,10
errmsg$ db  13,'ZIP -- fill all available memory with a specified byte',13,10
	db  'usage: "ZIP xx" where xx is a pair of hex digits',13,10,36
	db  100h dup (?)    ;room for our stack
endstack:

zip ends

	end	 entry

